/* Author: Denis Podgurskii */
import { ptk_exporter } from "../background/exporter.js"

export class ptk_controller_rbuilder {

    async sendRequest(requestFormId, schema) {
        return browser.runtime.sendMessage({
            channel: "ptk_popup2background_request",
            type: "send_request",
            schema: schema,
            requestFormId: requestFormId
        }).then(response => {
            return response
        })
    }


    async parseRawRequest(item) {
        return browser.runtime.sendMessage({
            channel: "ptk_popup2background_request",
            type: "parse_request",
            item: item
        }).then(response => {
            return response
        })
    }

    async updateRawRequest(item) {
        return browser.runtime.sendMessage({
            channel: "ptk_popup2background_request",
            type: "update_request",
            item: JSON.parse(JSON.stringify(item))
        }).then(response => {
            return response
        })
    }

    async export() {
        return browser.runtime.sendMessage({
            channel: "ptk_popup2background_request",
            type: "get_recording"
        }).then(response => {
            let exporter = new ptk_exporter(response, { format: "har" })
            let output = exporter.render()
            return output
        })
    }

}